<?
	class Chat
	{
		/* Variables */
		var $fichier_posts ;
		var $fichier_bans ;
		var $fichier_users ;
		var $fichier_clear ;		
		
		var $posts ;
		var $bans ;
		var $users ;
		
		var $posts_modif ;
		var $bans_modif ;
		var $users_modif ;
		
		var $TIMEOUT ;
		var $NB_CAR ;
		var $CLEAR ;	
		
		var $TEXT_ENTER = " est connect(e)" ;
		var $TEXT_QUIT = " est dconnect(e)" ;
		var $TEXT_QUIT_TIMEOUT = " est dconnect(e) (timeout)" ;
		var $TEXT_BAN = " a t banni(e) pour " ;
		var $TEXT_BAN_ENTER = " peut se reconnecter" ;
		var $TEXT_MODERATOR = " devient modrateur(trice)" ;
		var $TEXT_CLEAR = "Purge des posts effectue" ;
				
		/* Constructeur */
		
		function chat($NB_CAR=50, $TIMEOUT=300, $CLEAR=0, $fichier_posts="posts.txt", $fichier_bans="bans.txt", $fichier_users="users.txt", $fichier_clear="clear.txt")
		{
			$this->fichier_posts = $fichier_posts ;
			$this->fichier_bans = $fichier_bans ;
			$this->fichier_users = $fichier_users ;
			$this->fichier_clear = $fichier_clear ;

			$this->TIMEOUT = $TIMEOUT ;
			$this->NB_CAR = $NB_CAR ;
			$this->CLEAR = $CLEAR ;

			$this->posts_modif = false ;
			$this->bans_modif = false ;
			$this->users_modif = false ;
							
			// Cration des fichiers s'ils n'existent pas
			if(!file_exists($this->fichier_posts))
			{
				$fin = fopen($this->fichier_posts,"a+") ;
				fclose($fin) ;
			}
	
			if(!file_exists($this->fichier_bans))
			{
				$fin = fopen($this->fichier_bans,"a+") ;
				fclose($fin) ;
			}
	
			if(!file_exists($this->fichier_users))
			{
				$fin = fopen($this->fichier_users,"a+") ;
				fclose($fin) ;
			}
			
			if(!file_exists($this->fichier_clear))
			{
				$fin = fopen($this->fichier_clear,"a+") ;
				
				/* Dfinition de la prochaine purge des posts */
				if($this->CLEAR > 0)
				{
					fwrite($fin, mktime(date("H"),date("i"),date("s"),date("m"),date("d"),date("Y")) + $this->CLEAR) ;
				}
				
				fclose($fin) ;
			}			
			
			// Chargement des donnes
			if(filesize($this->fichier_posts)>0)
			{				
				// Purge des posts si ncessaire
				if(filesize($this->fichier_clear)>0)
				{
					$fin = fopen($this->fichier_clear,"r+") ;
					$tmp_clear = fread($fin, filesize($this->fichier_clear)) ;
					fclose($fin) ;
					
					if($tmp_clear > mktime(date("H"),date("i"),date("s"),date("m"),date("d"),date("Y")))
					{
						$fin = fopen($this->fichier_posts,"r+") ;
						$this->posts = explode("\n",fread($fin,filesize($this->fichier_posts))) ;
						fclose($fin) ;					
					}
					else
					{
						$fout = fopen($this->fichier_posts,"a+") ;
						fclose($fout) ;
						
						unlink($this->fichier_clear) ;
						
						$this->posts[0] = "" ;
						
						$this->postFromServer($this->TEXT_CLEAR." [".date("d/m/Y H:i:s")."]") ;
					}
				}
				else
				{
					$fin = fopen($this->fichier_posts,"r+") ;
					$this->posts = explode("\n",fread($fin,filesize($this->fichier_posts))) ;
					fclose($fin) ;				
				}				
			}
	
			if(filesize($this->fichier_bans)>0)
			{		
				$fin = fopen($this->fichier_bans,"r+") ;
				$this->bans = explode("\n",fread($fin,filesize($this->fichier_bans))) ;
				fclose($fin) ;
			}		
	
			if(filesize($this->fichier_users)>0)
			{
				$fin = fopen($this->fichier_users,"r+") ;
				$this->users = explode("\n",fread($fin,filesize($this->fichier_users))) ;
				fclose($fin) ;
			}
			
			// Mise  jour des Timeout et des reconnexions
			$this->clearUsers() ;
			$this->ClearBans() ;
		}
		
		/* Chargement des posts serveur */
		function setServerPosts($text1, $text2, $text3, $text4, $text5, $text6, $text7)
		{
			$this->TEXT_ENTER = $text1 ;
			$this->TEXT_QUIT = $text2 ;
			$this->TEXT_QUIT_TIMEOUT = $text3 ;
			$this->TEXT_BAN = $text4 ;
			$this->TEXT_BAN_ENTER = $text5 ;
			$this->TEXT_MODERATOR = $text6 ;
			$this->TEXT_CLEAR = $text7 ;
		}
		
		/* Tests boolens */
		
		// Renvoie vrai si l'utilisateur existe
		function isUser($nickname)
		{		
			$i = 0 ;
			while($this->users[$i])
			{
				$temp = explode(";",$this->users[$i]) ;
				
				if($temp[0]==$nickname)
					return 1 ;
				
				$i++ ;
			}
		
			return 0 ;
		}
		
		// Renvoie vrai si l'utilisateur est administrateur
		function isAdmin($nickname)
		{
			$i = 0 ;
			while($this->users[$i])
			{
				$temp = explode(";",$this->users[$i]) ;
			
				if($temp[0]==$nickname && $temp[2] == "@")
					return 1 ;
					
				$i++ ;
			}
		
			return 0 ;
		}
		
		// Renvoie vrai si l'ip est bannie
		function isBan($ip)
		{
		
			$i = 0 ;
			while($this->bans[$i])
			{
				$temp = explode(";",$this->bans[$i]) ;			
			
				if($temp[0]==$ip)
					return 1 ;
				
				$i++ ;
			}
		
			return 0 ;	
		}
		
		function getIp($nickname)
		{		
			$i = 0 ;
			while($this->users[$i])
			{
				$temp = explode(";",$this->users[$i]) ;
				
				if($temp[0]==$nickname)
					return $temp[3] ;
				
				$i++ ;
			}
		
			return 0 ;
		}
		
		/* Fonctions de sauvegarde des fichiers */
		
		function savePosts()
		{
			if($this->posts_modif)
			{
				$fout = fopen($this->fichier_posts,"w+") ;			
				if($this->posts[0])
					fwrite($fout, implode("\n", $this->posts)) ;
				fclose($fout) ;	
			}
		}
	
		function saveUsers()
		{
			if($this->users_modif)
			{
				$fout = fopen($this->fichier_users,"w+") ;			
				if($this->users[0])
					fwrite($fout, implode("\n", $this->users)) ;
				fclose($fout) ;	
			}
		}
	
		function saveBans()
		{
			if($this->bans_modif)
			{
				$fout = fopen($this->fichier_bans,"w+") ;
				if($this->bans[0])
					fwrite($fout, implode("\n", $this->bans)) ;
				fclose($fout) ;	
			}
		}
		
		/* Fonctions d'initialisation */
		
		function refreshUser($nickname)
		{
			$i = 0 ;
			while($this->users[$i])
			{
				$temp = explode(";",$this->users[$i]) ;
				$now = mktime(date("H"),date("i"),date("s"),date("m"),date("d"),date("Y")) ;
			
				if($temp[0]==$nickname && ($temp[1] + $this->TIMEOUT*0.7) <= ($now))
				{
					$this->users_modif = true ;	
					$this->users[$i] = $nickname.";".$now.";".$temp[2].";".$temp[3] ;
				}
				
				$i++ ;
			}						
		}
		
		function ClearUsers()
		{
			$i = 0 ;
			$now = mktime(date("H"),date("i"),date("s"),date("m"),date("d"),date("Y")) ;
			$ok = true ;
			
			while($this->users[$i])
			{
				$temp = explode(";",$this->users[$i]) ;
			
				if($now <= $temp[1] + $this->TIMEOUT)
				{
					$new_users[] = $this->users[$i] ;
				}
				else
				{
					$ok = false ;
					$this->postFromServer($temp[0].$this->TEXT_QUIT_TIMEOUT) ;
				}
				
				$i++ ;
			}				

			if(!$ok)
			{
				$this->users = $new_users ;
				$this->users_modif = true ;
			}						
		}
	
		function ClearBans()
		{
			$i = 0 ;
			$now = mktime(date("H"),date("i"),date("s"),date("m"),date("d"),date("Y")) ;
			$ok = true ;
	
			while($this->bans[$i])
			{
				$temp = explode(";",$this->bans[$i]) ;
			
				if($now <= $temp[1])
				{
					$new_bans[] = $this->bans[$i] ;
				}
				else
				{
					$ok = false ;
					$this->postFromServer($temp[0].$this->TEXT_BAN_ENTER) ;
				}
				
				$i++ ;
			}				

			if(!$ok)
			{
				$this->bans = $new_bans ;				
				$this->bans_modif = true ;
			}						
		}
		
		/* Commandes serveur */
	
		// Passage d'un utilisateur en administrateur
		function setAdmin($nickname)
		{
			if(!$this->isAdmin($nickname))
			{			
				$i = 0 ;
				while($this->users[$i])
				{
					$temp = explode(";",$this->users[$i]) ;
					
					if($temp[0]==$nickname)
					{
						$this->users[$i] = $nickname.";".mktime(date("H"),date("i"),date("s"),date("m"),date("d"),date("Y")).";@;".$temp[3] ;
					}
					
					$i++ ;
				}							
			
				$this->postFromServer("$nickname".$this->TEXT_MODERATOR." (".date("d/m/Y H:i:s").")") ;			
			}
			
			$this->users_modif = true ;
			$this->refreshUser($nickname) ;
		}
		
		// Poste un message pour un utilisateur
		function post($nickname, $message)
		{
			if($this->isUser($nickname))
			{
			
				//$temp = explode(" ","[".htmlentities($nickname, ENT_QUOTES)." ".date("H:i:s")."] ".htmlentities($message, ENT_QUOTES)) ;
				$temp = explode(" ","[$nickname ".date("H:i:s")."] $message") ;
				$len_tmp = strlen($temp) ;
				$res = "" ;
				$i = 0 ;
	
				while($temp[$i])
				{			
					if($i==0)
						$res .=  "<div class=\"autres_lignes\" onmouseover=\"mouseOver(this)\" onmouseout=\"mouseOut(this)\">" ;
			
					if($j + strlen($temp[$i]) > $this->NB_CAR)
					{
						if(strlen($temp[$i]) > $this->NB_CAR)
						{
							$temp2 = $temp[$i] ;
						
							while(strlen($temp2) > $this->NB_CAR)
							{						
								$temp3 = substr($temp2,$this->NB_CAR-3-$j,strlen($temp2) - $this->NB_CAR + 3 + $j) ;
								
								$res .= substr($temp2,0,$this->NB_CAR-3-$j)."...</div>\n<div class=\"autres_lignes\" onmouseover=\"mouseOver(this)\" onmouseout=\"mouseOut(this)\">" ;
						
								$temp2 = $temp3 ;
						
								$j = 0 ;
							}
					
							$res .= $temp2 ;
					
							$j = 0 ;
						}
						else
						{
							$j = 0 ;
							if($temp[$i+1])
								$res .= $temp[$i]."</div>\n<div class=\"autres_lignes\" onmouseover=\"mouseOver(this)\" onmouseout=\"mouseOut(this)\">" ;						
							else
								$res .= $temp[$i]." " ;
						}
					}
					else
					{
						$res .= $temp[$i]." " ;
						$j += strlen($temp[$i]) ;
					}
						
					$i++ ;
				}
		
				$res .= "</div>" ;
			
				//Inversement des lignes
				$i = 0 ;
		
				if(!(strpos($res,"\n")===false))
				{
					$temp = explode("\n",$res) ;
					
					$new_posts = array_reverse($temp) ;
				
					while($new_posts[$i++]) ;		
				}
				else
					$new_posts[$i++] = $res ;
			
				$j = 0 ;
				while($this->posts[$j])
				{
					$new_posts[$i] = $this->posts[$j] ;
					$i++ ;
					$j++ ;
				}
		
				$this->posts = $new_posts ;						
		
				$this->posts_modif = true ;
				$this->refreshUser($nickname) ;		
			}
		}
		
		function postFromServer($message)
		{
			$new_posts[0] = "<div class=\"serveur_lignes\">* ".htmlentities($message, ENT_QUOTES)."</div>" ;
		
			$i=0 ;
			while($this->posts[$i])
			{
				$new_posts[$i+1] = $this->posts[$i] ;
				$i++ ;
			}
		
			$this->posts_modif = true ;
			$this->posts = $new_posts ;
		}
	
		function quit($nickname)
		{
			if($this->isUser($nickname))
			{
				$i = 0 ;
				while($this->users[$i])
				{
					$temp = explode(";",$this->users[$i]) ;
					
					if($temp[0] != $nickname)
						$new_users[] = $this->users[$i] ;
	
					$i++ ;
				}
							
				
				$this->users = $new_users ;
				
				$this->users_modif = true ;
				
				$this->postFromServer("$nickname".$this->TEXT_QUIT." (".date("d/m/Y H:i:s").")") ;
			}		
		}
		
		function enter($nickname, $ip)
		{
			if(!$this->isban($ip) && !$this->isUser($nickname))
			{
				$this->users[] = $nickname.";".mktime(date("H"),date("i"),date("s"),date("m"),date("d"),date("Y")).";;".$ip ;
				
				$this->postFromServer("$nickname".$this->TEXT_ENTER." (".date("d/m/Y H:i:s").")") ;
				
				$this->users_modif = true ;
				
				return true ;
			}
			else
			{
				$this->refreshUser($nickname) ;
				
				return false ;
			}
		}
	
		function ban($nickname, $banned, $ip, $sec)
		{
			if($this->isUser($banned) && $this->isAdmin($nickname))
			{
			
				$this->quit($banned) ;
				
				$this->bans[] = $ip.";".(mktime(date("H"),date("i"),date("s"),date("m"),date("d"),date("Y")) + $sec) ;
				
				$this->bans_modif = true ;
				
				$this->postFromServer("$banned ($ip)".$this->TEXT_BAN." $sec s.") ;				
			}
		}
		
		/* Oprateurs d'affichage */
		
		function printPosts($nickname, $NB_LIGNES, $position)
		{			
			
			$i = 0 + $position ;
			$j = 0 ;	
			while($j < $NB_LIGNES)
			{
				if($i == 0)
					$affichage = str_replace("autres_lignes","premiere_ligne",$this->posts[$i]).$affichage ;
				else
					$affichage = $this->posts[$i].$affichage ;
				
				$i ++ ;
				$j ++ ;
			}
		
			$this->refreshUser($nickname) ;
			
			return $affichage ;
		}
		
		function printUsers($nickname)
		{
				
			if($this->users[0])
			{		
				array_multisort($this->users) ;

				$i = 0 ;
				while($this->users[$i])
				{
					$temp = explode(";",$this->users[$i]) ;
				
					$affichage .= "<div class=\"users_lignes\" onmouseover=\"mouseOver(this)\" onmouseout=\"mouseOut(this)\">".$temp[2].$temp[0]."</div>" ;
				
					$i ++ ;
				}		
			}
			
			$this->refreshUser($nickname) ;
			
			return $affichage ;
		}	
		
		/* Destructeur */
		
		function release()
		{
			$this->savePosts() ;
			$this->saveUsers() ;
			$this->saveBans() ;			
		}
					
	}
?>